"""
    Demo a DynamicPolicy hasznlatra
    Attrs pldnyainak nincs metdusa, de tetszleges szm tulajdonsga lehet, melyek
    futsidben egyszer rtkadssal keletkeznek. Termszetesen hiba generldik, ha
    olyan tulajdonsgra hivatkozunk akinek mg nem lett rtk adva. Futs kzben egy mr
    ltez tulajdonsg tipusa megvltoztathat, egyszeren egy ms tipus rtket
    pakolunk bele(ez nem gy hiszen a Python gy mkdik).
"""
import pythoncom
import winerror
from win32com.server.exception import COMException
import string

class Attrs:
    """
        Demo a DynamicPolicy hasznlatra
    """
    # szoksos regisztrcis adatok
    _reg_desc_          = 'Attrs demo class'
    _reg_clsid_         = '{CFFDFAAB-AD71-48B1-A478-695B44617AA0}'
    _reg_progid_        = 'Demo.Attrs'
    _reg_verprogid_     = 'Demo.Attrs.1'
    _reg_policy_spec_   = 'DynamicPolicy'

    # kigyjtttem ide azokat a regisztrcihoz s mkdshez hasznlatos elmeket,
    # akiket nem akarunk elrhetv tenni a COM-os felleten keresztl
    _tiltott_nevek_     = ['_reg_desc_',
                           '_reg_clsid_',
                           '_reg_progid_',
                           '_reg_verprogid_',
                           '_reg_policy_spec_',
                           '_tiltott_nevek_',
                           '_dynamic_']

    def _dynamic_(self, name, lcid, wFlags, args):
        name=string.lower(name) # mindent kisbetre konvertlok, hogy ne legyen kavar
        if name in self._tiltott_nevek_:
            raise COMException("%s hasznlata tiltott!" % name,winerror.DISP_E_EXCEPTION)
        if wFlags & pythoncom.DISPATCH_METHOD:
            raise COMException("A metdushvs tiltott!",winerror.DISP_E_EXCEPTION)
        elif wFlags & pythoncom.DISPATCH_PROPERTYGET:
            # figyelni kell, mert lehet mg nincs ilyen tulajdonsg
            try:
                return getattr(self,name)
            except AttributeError:
                # DISP_E_MEMBERNOTFOUND nem j, mert a Python kliens erre azt hiszi, hogy metdusrl
                # van sz. A Python szmra a metdus is csak egy attributum, ezrt elszr
                # DISPATCH_PROPERTYGET-el prblkozik s ha DISP_E_MEMBERNOTFOUND-ot kap vissza, akkor
                # metdusnak hiszi
                raise COMException("Nincs %s nev tulajdonsg!" % name,winerror.DISP_E_UNKNOWNNAME)
        elif wFlags & (pythoncom.DISPATCH_PROPERTYPUT | pythoncom.DISPATCH_PROPERTYPUTREF):
            # itt nem lehet hiba
            setattr(self,name,args[0])
            return
        else:
            raise COMException("invalid wFlags", winerror.E_INVALIDARG)

def Register():
    # szoksos regisztrls, de a policy nem az alaprtelmezett DesignatedWrapPolicy lesz,
    # hanem a H2O class _reg_policy_spec_ attributumban belltott DynamicPolicy
    from win32com.server.register import UseCommandLine
    return UseCommandLine(Attrs)

if __name__=='__main__':
    Register()
